//
// Copyright (C) 2008 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef	__ANON_PRIMITIVE_BENCHMARK_H
#define __ANON_PRIMITIVE_BENCHMARK_H

#include "../anonprimitives/AnonFactory.h"
#include <list>
#include <ctime>
#include <cstdlib>

using std::vector;
using std::pair;

#define BENCH_MAX_BUFFER_SIZE		 2000
#define BENCH_RUN_COUNT				   10

class AnonPrimitiveBenchmark
{
public:
						AnonPrimitiveBenchmark			();
						~AnonPrimitiveBenchmark			();

	void				run								();
	
	typedef pair<string, string>						ANON_RESULT_PAIR;
	ANON_RESULT_PAIR	getResult						(unsigned int idx);

	unsigned int		getResultCount					();

private:

	typedef pair<string, AnonPrimitive*>		ANON_NAME_PAIR;
	typedef vector<ANON_RESULT_PAIR>			RESULT_LIST;

	RESULT_LIST			results;
	ANON_NAME_PAIR		next							();

};

#endif // __ANON_PRIMITIVE_BENCHMARK_H
